#
# lang-stats_fishing.R,  9 Jun 24

library("colorspace")
library("plyr")


par(bty="l")
par(las=1)
par(pch="+")
pal_col=rainbow(2)


sv=read.csv("stack_v2_language_stats.csv", as.is=TRUE)
wpl=read.csv("PL_wikipedia.txt", as.is=TRUE)

sv$language=tolower(sv$language)
wpl$language=tolower(wpl$language)

sv_in_wpl=(sv$language %in% wpl$language)
wpl_in_sv=(wpl$language %in% sv$language)

sum(sv_in_wpl)
nrow(sv)

plot(sv$num_files, sv$size_bytes, log="xy", col=pal_col[2],
	xlab="Files", ylab="Bytes")

sv_mod=glm(log(size_bytes) ~ log(num_files), data=sv)
summary(sv_mod)

x_range=10^(1:9)
pred=predict(sv_mod, newdata=data.frame(num_files=x_range))
lines(x_range, exp(pred), col=pal_col[1])

l1=subset(sv, grepl("VM", language, ignore.case=TRUE))

